/*
 * Copyright (c) 2024, NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 */

#ifndef __VIRTNET_DPA_AARFS_H__
#define __VIRTNET_DPA_AARFS_H__

extern flexio_func_t virtnet_dpa_aarfs_sync_handle;
extern flexio_func_t virtnet_dpa_aarfs_to_host_copy;

int virtnet_dpa_aarfs_init(struct ibv_pd *emu_mgr_ibv_pd,
			   struct virtnet_dpa_ctx *dpa_ctx, uint16_t max_pfs);
void virtnet_dpa_aarfs_uninit(struct virtnet_dpa_ctx *dpa_ctx);
cJSON *
virtnet_dpa_aarfs_hash_dump(void *handler, struct ibv_pd *emu_mgr_ibv_pd,
			    int dev_id);
cJSON *
virtnet_dpa_aarfs_mru_dump(void *handler, struct ibv_pd *emu_mgr_ibv_pd);
cJSON *
virtnet_dpa_aarfs_stats_dump(void *handler, struct ibv_pd *emu_mgr_ibv_pd);
int
virtnet_dpa_aarfs_add_info_fetch(void *handler, uint16_t eu, uint16_t *dev_id,
				 uint16_t *src_port, uint16_t *dst_port,
				 uint16_t *rq_idx, uint8_t *q_state);
int
virtnet_dpa_aarfs_del_info_fetch(void *handler, uint16_t *dev_id,
				 uint16_t *src_port, uint16_t *dst_port,
				 uint16_t *rq_idx, uint8_t *q_state);
int virtnet_dpa_aarfs_config_dev(struct virtnet_device *dev, bool enable);
int virtnet_dpa_aarfs_config(struct virtnet_device *dev, bool enable);
int virtnet_dpa_aarfs_num_of_add_q_get(uint16_t dpa_core_start,
				       uint16_t dpa_core_end);
#endif
